#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use psfp;
use Time::Local; 
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&edit_email;}
if ($q->param('fct') eq "save_email") {&save_email;}
if ($q->param('fct') eq "retrieve_pass") {&edit_email_retpass;}
if ($q->param('fct') eq "save_email_ret_pass") {&save_email_ret_pass;}



##################################################################################

sub save_email_ret_pass
{

if ($q->param('from_name') eq ""){acs::problem_popup("You have to supply a name from whom email is sent.");}
if ($q->param('from_email') eq ""){acs::problem_popup("You have to supply an email address from where email is sent.");}
if ($q->param('email_subject') eq ""){acs::problem_popup("The email needs a subject.");}
if ($q->param('email_message') eq ""){acs::problem_popup("The email needs a message.");}

open (AME, "> $data_dir/retrievepass.eml");
	print AME $q->param('from_name') . "\n";
	print AME $q->param('from_email') . "\n";
	print AME $q->param('email_subject') . "\n";
	print AME $q->param('email_message') . "\n";
close (AME);



$hbox = acs::get_heading_box("$web_url/ic_email1.gif", "Password Retrieval Email Saved", qq[
<a href="$admin_url/admin16.cgi">Click here to continue.</a>
]); 



print qq[

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox

</body>
</html>

];

}




sub edit_email_retpass
{

$emailmsg = acs::get_file_contents("$data_dir/retrievepass.eml");

@elines = split (/\n/, $emailmsg);

$from_name = $elines[0];
$from_email = $elines[1];
$email_subject = $elines[2];

$lnc = 0;
foreach $line (@elines)
	{
	if ($lnc > 2)
		{
		$email_message = $email_message . $line . "\n";
		}
	$lnc++;
	}

$from = $q->param('from');


$hbox = acs::get_heading_box("$web_url/ic_email1.gif", "Password Retrieval Email", qq[
This email is sent to the email addresses of users requesting that their user name and password be sent to them through the password retrieval function. 
<BR><a href="$admin_url/admin16.cgi"><b>Go Back</b></a>
]); 


$helpb = acs::quick_help("Variables Available For Use In This Email ",qq[
<p align="left"><strong>%%name%% </strong><br>
Name of user. </p>

<p align="left"><strong>%%user_name%% <br>
</strong>Account user name. </p>

<p align="left"><strong>%%password%% <br>
</strong>Account password. </p>

<p><strong>%%login_link%% <br>
</strong>Link to the user login script. </p>
]);





print <<END_OF_EM;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>



$hbox

<form method="POST" action="$admin_url/admin54.cgi">
  <input type="hidden" name="fct" value="save_email_ret_pass"><table border="0"
  cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td colspan="2" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Email
      Details:</strong></td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">From Name: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="from_name" size="40"
      value="$from_name" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">From Email: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="from_email" size="40"
      value="$from_email" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">Email Subject: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="email_subject" size="57"
      value="$email_subject" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" valign="top" bgcolor="#FFFFFF" class="normaltext">Message: </td>
      <td width="85%" bgcolor="#FFFFFF"><textarea rows="24" name="email_message" cols="77"
      style="width:100%">$email_message
</textarea> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF"></td>
      <td width="85%" bgcolor="#FFFFFF"><input type="submit" value="   Save   " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>


$helpb




</body>
</html>

END_OF_EM



}




sub save_email
{

if ($q->param('from_name') eq ""){acs::problem_popup("You have to supply a name from whom email is sent.");}
if ($q->param('from_email') eq ""){acs::problem_popup("You have to supply an email address from where email is sent.");}
if ($q->param('email_subject') eq ""){acs::problem_popup("The email needs a subject.");}
if ($q->param('email_message') eq ""){acs::problem_popup("The email needs a message.");}

open (AME, "> $data_dir/validation.eml");
	print AME $q->param('from_name') . "\n";
	print AME $q->param('from_email') . "\n";
	print AME $q->param('email_subject') . "\n";
	print AME $q->param('email_message') . "\n";
close (AME);


$hbox = acs::get_heading_box("$web_url/ic_email1.gif", "User Registration System Activation Email Saved", qq[
<a href="$admin_url/admin16.cgi">Click Here to continue</a>
]); 



print <<END_OF_SAVED;
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox

</body>
</html>

END_OF_SAVED


}






sub edit_email
{

#($extradfk) = acs::get_extra_vars;
#if ($extradfk ne ""){$extradfk = "<font face=\"Verdana\" size=\"1\" color=\"#8080FF\"><b>Listed below is extra field/key variables that may be used with this email.</b><br><br></b>$extradfk<b></font>";}

$emailmsg = acs::get_file_contents("$data_dir/validation.eml");

@elines = split (/\n/, $emailmsg);

$from_name = $elines[0];
$from_email = $elines[1];
$email_subject = $elines[2];

$lnc = 0;
foreach $line (@elines)
	{
	if ($lnc > 2)
		{
		$email_message = $email_message . $line . "\n";
		}
	$lnc++;
	}

$from = $q->param('from');


$hbox = acs::get_heading_box("$web_url/ic_email1.gif", "User Registration System Activation Email", qq[
When a user registers an account then an activation email is sent to the email address of the user. The user must then click the link inside this email to activate the account. You can customize this email that is sent to users registering new accounts by clicking the heading above. When you use the user registration system then users are required to create an account before being able to post a link. 
<BR><a href="$admin_url/admin16.cgi"><b>Go Back</b></a>
]); 


$helpb = acs::quick_help("Variables Available For Use In This Email ",qq[
<p align="left"><strong>%%activation_link%% <br>
</strong>The link that the user must click to activate their account. </p>

<p align="left"><strong>%%name%% </strong><br>
Name of user. </p>

<p align="left"><strong>%%user_name%% <br>
</strong>Account user name. </p>

<p align="left"><strong>%%password%% <br>
</strong>Account password. </p>
]);


print <<END_OF_EM;
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox



<form method="POST" action="$admin_url/admin54.cgi">
  <input type="hidden" name="fct" value="save_email"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td colspan="2" bgcolor="#FFFFFF" class="normaltext" background="$web_url/bar6.gif"><strong>Email
      Details:</strong></td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">From Name: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="from_name" size="40"
      value="$from_name" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">From Email: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="from_email" size="40"
      value="$from_email" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">Email Subject: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="email_subject" size="57"
      value="$email_subject" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" valign="top" bgcolor="#FFFFFF" class="normaltext">Message: </td>
      <td width="85%" bgcolor="#FFFFFF"><textarea rows="24" name="email_message" cols="77"
      style="width:100%">
$email_message
</textarea> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF"></td>
      <td width="85%" bgcolor="#FFFFFF"><input type="submit" value="   Save   " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>


$helpb




</body>
</html>

END_OF_EM


}




sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

